(****************************************************************************)
(*                                                                          *)
(*      Dieses Pascalprogramm stellt Ihnen eine SAA-Oberflche              *)
(*      zur Verfgung, mit der Sie komfortabel geeignete Daten              *)
(*      laden, speichern und bearbeiten knnen, um damit das                *)
(*      Sternbewegungsprogramm Star zu starten. Das Programm                *)
(*      Star berechnet und zeichnet die Bewegung von Planeten               *)
(*      in der Ebene mit den gegebenen Daten als Anfangswerte.              *)
(*                                                                          *)
(****************************************************************************)

Program Sterne;

{$N+,E+}

uses
  Dialogs,                             (*****************************)
  Drivers,                             (*                           *)
  Views,                               (* Diese Units sind standart *)
  Menus,                               (*  Turbo-Vision Units       *)
  Objects,                             (*                           *)
  App,                                 (*****************************)

  Fields,                              (*****************************)
  StdDlg,                              (*  nicht Standart TV-Units  *)
  MsgBox,                              (*****************************)

  Dos,                                 (*    DOS-Schnittstelle      *)

  RealIn,                              (* Eigene Units, die auf der *)
  Star;                                (*  Diskette enthalten sind  *)

type
  tSternApp = Object (tApplication)
                constructor Init;
                procedure FileSearchOpen;
                procedure Speichern;
                procedure WoSpeichern;
                procedure SaveAs;
                procedure InitMenuBar; virtual;
                procedure InitStatusLine; virtual;
                procedure HandleEvent(var event:tEvent); virtual;
              end;

const
  cmVorDat   = 101;
  cmNeueDat  = 102;
  cmSternRun = 103;
  cmAnzIt    = 104;
  cmGenau    = 105;
  cmGruss    = 106;
  cmMehr     = 107;
  cmSave     = 108;
  cmWoSave   = 109;
  cmAktuell  = 110;
  cmSaveAs   = 111;
  cmOpen     = 112;

var
  SternApp        : tSternApp;
  Ereigniss       : tEvent;
  Star0           : Werte;
  EingabeFenster  : pDialog;
  i,j             : integer;

var                                    (* Diese globalen Variablen werden  *)
  DatAktu,DatSave : PathStr;           (*  zur Laufzeit des Programms      *)
  StarAktu        : Werte;             (*  stndig aktualisiert und        *)
  AnzSterne       : integer;           (*  berschrieben.                  *)
  itera,genau     : longint;

Procedure AnzahlSterne(Sterne:Werte; var Anzahl:integer);
(* Zhlt als Anzahl nur die Sterne durch, bis die erste Masse 0 ist  *)
begin
  i:=0;
  While (Sterne[i+1,1] <> 0 ) and (i<14) do
    i:=i+1;
  Anzahl:=i;
end;
        
Procedure DateiLesen(SternDatei:PathStr;var Sterne:Werte);
(*  Liest die Werte der externen Datei  *)
var
  datei   : Text;
begin
  assign(datei,SternDatei);
  reset(datei);
  for i:=1 to 14 do
    for j:= 1 to 5 do
      read(datei,Sterne[i,j]);
  close(datei);
  AnzahlSterne(StarAktu,AnzSterne);
  DatAktu:=SternDatei;
end;

Procedure tSternApp.FileSearchOpen;
(* ffnet Dateiauswahlfenster und nach der Wahl die gewnschte Datei  *)
Var
  D: pFileDialog;
  FileName: PathStr;
  Suchweg,Weg : DirStr;
  Name    : NameStr;
  Suffix  : ExtStr;
  w       : Word;
  pfad    : PathStr;
begin
  Weg:=FExpand('DATEN\');
  chdir('DATEN');
  D:=New(pFileDialog,Init('*.DAT', 'DateiSuche',
     'Dateien fr Planeten', fdOpenButton, 100 ));
  if Application^.ValidView(D) <> nil then
  begin
    if DeskTop^.ExecView(D) <> cmCancel then
      begin
        D^.GetFileName(FileName);
        for i:=1 to length(FileName)do
          FileName[i]:=upcase(FileName[i]);
        FSplit(FileName,Suchweg,Name,Suffix);
        if (Suffix=('.DAT')) and (Suchweg=Weg) then
          begin
            pfad:= FSearch(FileName,'a:;b:;c:;d:');
            if pfad<>'' then
              DateiLesen(FileName,StarAktu)
            else begin
                   w:=MessageBox('Gewnschte Datei existiert nicht.',nil, mfError + mfOkButton);
                   Ereigniss.What:=evCommand;           
                   Ereigniss.Command:=cmOpen;
                   PutEvent(Ereigniss);
                 end;
          end
        else begin
               w:=MessageBox('Ich kann nur *.DAT_Dateien aus DATEN\ verwenden.',nil, mfError + mfOkButton);
               Ereigniss.What:=evCommand;           
               Ereigniss.Command:=cmOpen;
               PutEvent(Ereigniss);
             end;
      end;
  Dispose(D,Done);
  chdir('..');
  end;
end;

Function DatenTest(Anzahl:integer;Sterne:Werte):boolean;
(* Testet die aktuellen Werte auf unzulssige Daten und meldet Fehler  *)
var
  w : word;
  Summe : real;
function sigma(x:double):integer;
  begin
    if x=0 then sigma:=0
    else sigma:=1;
  end;
begin
  Summe:=0;
  DatenTest:=true;
  if Anzahl<2 then
    begin
      w:=MessageBox('Sie mssen mindestens zwei Sterne angeben.',nil, mfError + mfOkButton);
      DatenTest := false;
    end;
  Summe:=1;
  for i:=1 to (Anzahl-1) do
    for j:=(i+1) to Anzahl do
      Summe:=Summe*(sigma(Sterne[i,2]-Sterne[j,2])+sigma(Sterne[i,3]-Sterne[j,3]));
  if Summe=0 then
    begin
      w:=MessageBox('Bitte nicht mehrere Sternen auf eine Position setzen.',nil, mfError + mfOkButton);
      DatenTest := false;
    end;
  Summe:=1;
  for i:=1 to 14 do
    begin
      if Sterne[i,1]<0 then Summe:=0;
    end;
  if Summe=0 then
    begin
      w:=MessageBox('Wat soll denn dat? Negative Masse?',nil, mfError + mfOkButton);
      DatenTest := false;
    end;
end;

Procedure DateiSchreiben(SternDatei:PathStr; Sterne:Werte);
(* Schreibt die Werte der Variablen Sterne in die angegebene Datei  *)
var
  datei   : Text;
begin
  assign(datei,SternDatei);
  rewrite(datei);
  for i:=1 to 14 do
    for j:= 1 to 5 do
      writeln(datei,Sterne[i,j]);
  close(datei);
  DatAktu:=SternDatei;
end;
  
Procedure tSternApp.SaveAs;
(* ffnet Dateiauswahlfenster zur Speicherung und prft den gewhlten Pfad *)
Var
  D: pFileDialog;
  FileName: PathStr;
  Suchweg,Weg: DirStr;
  Name    : NameStr;
  Suffix  : ExtStr;
  w       : Word;
  pfad    : PathStr;
begin
  Weg:=FExpand('DATEN\');
  chdir('DATEN');
  D:=New(pFileDialog,Init('*.DAT', 'Speichern unter',
     '', fdOkButton, 100 ));
  if Application^.ValidView(D) <> nil then
  begin
    if DeskTop^.ExecView(D) <> cmCancel then
      begin
        D^.GetFileName(FileName);                     (* den  Pfad lesen   *)
        for i:=1 to length(FileName)do
          FileName[i]:=upcase(FileName[i]);
        FSplit(FileName,Suchweg,Name,Suffix);         (* Gltigkeit prfen *)
        if (Suffix=('.DAT')) and (Suchweg=Weg) then
          begin
            pfad:= FSearch(FileName,'a:;b:;c:;d:');   (* wenn gltig und   *)
            if pfad='' then                           (*  noch nicht ex.   *)
              DateiSchreiben(FileName,StarAktu)       (*  dann schreiben   *)
            else
              begin                                   (* wenn schon ex.    *)
                DatSave:=FileName;                    (*  dann Anfrage     *)
                Ereigniss.What:=evCommand;            (*  ob berschreiben *)
                Ereigniss.Command:=cmWoSave;
                PutEvent(Ereigniss);
              end;
          end
        else
          begin
            w:=MessageBox('Ich speicher nur *.Dat_Daten unter DATEN\ ab.',nil, mfError + mfOkButton);
            Ereigniss.What:=evCommand;
            Ereigniss.Command:=cmSaveAs;              (* wenn ungltig     *)
            PutEvent(Ereigniss);                      (*  wiederholen      *)
          end;
      end;
  end;
  Dispose(D,Done);
  chdir('..');
end;

Procedure tSternApp.WoSpeichern;
(* Abfrage, ob Datei berschrieben werden soll  *)
var
  Dlg : pDialog;
  R : TRect;
  Text : PStaticText;
  Control : PView;
begin
  R.Assign(17,2,64,10);
  New(Dlg, Init(R,''));
    R.Assign(2,1,46,4);
    Text := New(pStaticText, Init(R,'Mchten Sie die alten Werte von '+DatSave+' berschreiben?'));
    Dlg^.Insert(text);
  R.Assign(4,5,14,7);
  Control := New(pButton, Init(R, '~A~bbruch', cmCancel, bfDefault));
  Dlg^.Insert(Control);
    R.Assign(16,5,26,7);
    Control := New(pButton, Init(R, '~J~a', cmYes, bfNormal));
    Dlg^.Insert(Control);
  R.Assign(28,5,38,7);
  Control := New(pButton, Init(R, '~N~ein', cmNo, bfNormal));
  Dlg^.Insert(Control);
  case  DeskTop^.ExecView(Dlg) of
    cmYes: DateiSchreiben(DatSave,StarAktu);         (* berschreibt Daten *)
    cmNo : begin
             Ereigniss.What:=evCommand;              (* neue Auswahl       *)
             Ereigniss.Command:=cmSaveAs;
             PutEvent(Ereigniss);
           end;
    end;
  Dispose(Dlg, Done);
end;

Procedure tSternApp.Speichern;
begin
  DatSave:=DatAktu;
   if DatSave='Neu' then
     begin
       Ereigniss.What:=evCommand;
       Ereigniss.Command:=cmSaveAs;
       PutEvent(Ereigniss);
     end
   else
     begin       
       Ereigniss.What:=evCommand;
       Ereigniss.Command:=cmWoSave;
       PutEvent(Ereigniss);
     end;
end;

Procedure MachEingabe(Titel,Vor:String;max:integer;var Fenster:pDialog);
(* ffnet Eingabefenster fr eine Integerzahl  *)
var
  Dlg : pDialog;
  R : TRect;
  Control, Labl, Histry : PView;
begin
  R.Assign(17,2,64,14);
  New(Dlg, Init(R,'Eingabe' ));
  R.Assign(27,5,31,6);
  Control := New(pNumInputLine, Init(R,2,1,max));
  Dlg^.Insert(Control);
    R.Assign(11,2,46,3);
    Labl := New(pLabel, Init(R, Titel, Control));
    Dlg^.Insert(Labl);
    R.Assign(15,5,26,6);
    Labl := New(pLabel, Init(R, Vor, Control));
    Dlg^.Insert(Labl);
  R.Assign(24,8,36,10);
  Control := New(pButton, Init(R, ' ~O~k ', cmOK, bfDefault));
  Dlg^.Insert(Control);
  R.Assign(11,8,23,10);
  Control := New(pButton, Init(R, '~A~bbruch', cmCancel, bfNormal));
  Dlg^.Insert(Control);
  Dlg^.SelectNext(false);
  Fenster := Dlg;
end;

Procedure SternEingabe(Anzahl:integer; Titel:String; var Fenster:pDialog);
(* ffnet Eingabefenster fr die gesamten Sterndaten   *)
var
  Dlg : pDialog;
  R : TRect;
  Control, Labl, Histry : PView;
  k : integer;
  text : string;
begin
  if Anzahl<8 then k:=2
    else k:=1;
  R.Assign(0,0,80,23);
  New(Dlg,Init(R,Titel));
    R.Assign(10,1,22,2);
    Labl := New(pLabel, Init(R,'Masse:', Control));
    Dlg^.Insert(Labl);
      R.Assign(10,2,22,3);
      Labl := New(pLabel, Init(R,'( kg )', Control));
      Dlg^.Insert(Labl);
    R.Assign(23,1,35,2);
    Labl := New(pLabel, Init(R,'X-Pos.:', Control));
    Dlg^.Insert(Labl);
      R.Assign(23,2,35,3);
      Labl := New(pLabel, Init(R,'( m )', Control));
      Dlg^.Insert(Labl);
    R.Assign(36,1,48,2);
    Labl := New(pLabel, Init(R,'Y-Pos.:', Control));
    Dlg^.Insert(Labl);
      R.Assign(36,2,48,3);
      Labl := New(pLabel, Init(R,'( m )', Control));
      Dlg^.Insert(Labl);
    R.Assign(49,1,61,2);
    Labl := New(pLabel, Init(R,'X-Geschw.:', Control));
    Dlg^.Insert(Labl);
      R.Assign(49,2,61,3);
      Labl := New(pLabel, Init(R,'( m/s )', Control));
      Dlg^.Insert(Labl);
    R.Assign(62,1,74,2);
    Labl := New(pLabel, Init(R,'Y-Geschw.:', Control));
    Dlg^.Insert(Labl);
      R.Assign(62,2,74,3);
      Labl := New(pLabel, Init(R,'( m/s )', Control));
      Dlg^.Insert(Labl);
    for j:=1 to Anzahl do
      begin
        str(j,text);
        text:='Stern'+text+':';
        R.Assign(1,(k*j+3),10,(k*j+4));
        Labl := New(pLabel, Init(R,(text), Control));
        Dlg^.Insert(Labl);
      end;
  for j:=1 to Anzahl do
    for i:=0 to 4 do
      begin
        R.Assign((i*13+10),(k*j+3),(i*13+22),(k*j+4));
        Control := New(pRealInputLine, Init(R,20));
        Dlg^.Insert(Control);
      end;
  R.Assign(49,20,61,22);
  Control := New(pButton, Init(R,'~A~bbruch', cmCancel, bfNormal)); 
  Dlg^.Insert(control);
    R.Assign(62,20,74,22);
    Control := New(pButton, Init(R, ' ~O~k ', cmOK, bfDefault));
    Dlg^.Insert(Control);
  Dlg^.SelectNext(false);
  Fenster := Dlg;
end;

Constructor tSternApp.Init;
(* Constructor mit Belegung der Anfangswerte  *)
var
  i : integer;
begin
  tApplication.Init;
  itera := 5;
  genau := 8;
  for i := 1 to 14 do
    for  j := 1 to 5 do
      Star0[i,j] := 0;
  DatAktu := 'DATEN\Stern2.DAT';
  DateiLesen(DatAktu, StarAktu);
  AnzahlSterne(StarAktu,AnzSterne);
end;

Procedure tSternApp.InitMenuBar;
(* Einrichten der Menleiste  *)
var
  R:TRect;
begin
  GetExtent(R);
  R.B.Y := R.A.Y + 1;
  MenuBar := New(pMenuBar,Init(R,NewMenu(
          NewSubMenu('  ~D~atei  ', 0 ,NewMenu(
            NewItem('~V~orhandene Dateien',' ', kbAltV, cmVorDat, 0 ,
            NewItem('~N~eue Daten...',' ', kbAltN, cmNeueDat, 0 ,
            NewItem('Daten ~e~rweitern...','', kbAltE, cmMehr, 0 ,
            NewItem('Daten ~s~peichern','', kbAltS, cmSave, 0 ,
            NewItem('Begrung','  ', 0 , cmGruss, 0 ,
            NewLine(
            NewItem('E~x~it','Alt-X', kbAltX, cmQuit, 0 ,
            nil )))))))),
          NewSubMenu(' ~O~ptionen', 0 ,NewMenu(
            NewItem('~A~nzahl der Iterationen...',' ', kbAltA, cmAnzIt, 0 ,
            NewItem('~G~enauigkeit... ',' ', kbAltG, cmGenau, 0 ,
            NewItem('a~k~tuelle Daten...',' ',kbAltk, cmAktuell, 0 ,
            nil )))),
          NewItem('   ~S~tart   ','Alt-S', kbAltS, cmSternRun, 0 ,
            nil ))))));
end;

procedure tSternApp.InitStatusLine;
(* Einrichten der Statuszeile  *)
var
  R : TRect;
begin
  GetExtent(R);
  R.A.Y := R.B.Y - 1;
  StatusLine := New(pStatusLine, Init(R,
          NewStatusDef(0 ,$FFFF,
            NewStatusKey('~Alt-X~ Exit',kbAltX, cmQuit,
            nil ),
          nil )));
end;

Procedure tSternApp.HandleEvent;

Procedure SternDaten(Anz:integer;Titel:String;Sterne:Werte);
(* Eingabefenster fr Sterndaten aufrufen und Daten lesen  *)
begin
  SternEingabe(Anz,Titel,EingabeFenster);
  EingabeFenster^.SetData(Sterne);
  if  DeskTop^.ExecView(EingabeFenster) = cmOk then
    begin
      EingabeFenster^.GetData(StarAktu);
      if Sterne[1,1] = 0 then
        DatAktu:='Neu';
    end;
  Dispose(EingabeFenster, Done);
  AnzahlSterne(StarAktu,AnzSterne);
end;

Procedure Gruss;
var
  Text : String;
  w : Word;
begin
  Text := ('Dies ist ein Programm, da die planetaren Bahnen von');
  Text := Text + (' Sternen in der Ebene nachzeichnet. Viel Spa damit.');
  w := MessageBox(Text,nil, mfInformation);
end;

Procedure SternRun;
(* Das Sternbewegungsprogramm wird mit den aktuellen Daten gestartet  *)
var
  err : integer;
  w : word;
begin
  if Datentest(AnzSterne,StarAktu) = true then
  begin
    err:=0;
    DoneEvents;
    Stern(genau,itera,AnzSterne,StarAktu,err);
    SternApp.Redraw;
    InitEvents;
    if err <> 0 then
      w:=MessageBox('Fehler in der Berechnung aufgetreten.', nil, mfError+mfOkbutton);
  end;
end;

Procedure AnzIt;
(* Aufruf der Eingabe fr Integerzahlen und Werte fr AnzIt lesen  *) 
begin
  MachEingabe('Anzahl der Iterationen','Maximal:', 99, EingabeFenster);
  EingabeFenster^.SetData(itera);
  if DeskTop^.ExecView (EingabeFenster) = cmOk then
  EingabeFenster^.GetData(itera);
  Dispose(EingabeFenster, Done);
end;

Procedure GenauEin;
(* Aufruf der Eingabe fr Integerzahlen und Werte fr Genauigkeit lesen  *) 
begin
  MachEingabe('Genauigkeit der Rechnung','Eps:=1/1e', 15, EingabeFenster);
  EingabeFenster^.SetData(genau);
  if  DeskTop^.ExecView (EingabeFenster) = cmOk then
  EingabeFenster^.GetData(genau);
  Dispose(EingabeFenster, Done);
end;

begin
  tApplication.HandleEvent(event);
  if event.what = evCommand then
    begin
      case event.command of
        cmVorDat : FileSearchOpen;
        cmNeueDat : SternDaten(14,'Neue Daten',Star0);
        cmAktuell : SternDaten(anzSterne,DatAktu,StarAktu);
        cmGruss : Gruss;
        cmSternRun : SternRun;
        cmAnzIt : AnzIt;
        cmGenau : GenauEin;
        cmMehr : SternDaten(14,DatAktu,StarAktu);
        cmSave : Speichern;
        cmSaveAs : SaveAs;
        cmWoSave : WoSpeichern;
        cmOpen : FileSearchOpen;
      else
        Exit;
      end;
  end;
  ClearEvent (event);
end;


Begin    (* Sternmaske *)
  SternApp.Init;
  SternApp.Run;
  SternApp.Done;
end.